/*
HMPeg ATAPI routinen v1.0
Last change 19.05.2000

License : GPL
(c) Adam Majerczyk
04.03.2000	first release
19.05.2000	drive_att wird nicht mehr benoetigt.
*/

#include "my_defs.h"
#include "memory.h"
#include "serial.h"
#include "tools.h"
#include "ide.h"
#include "atapi.h"
#include "lcd.h"

extern unsigned char ERRNO;
extern unsigned char drive_slots;

unsigned char ASC;
unsigned char ASCQ;

void clr_cmd(void)
{
	memset((unsigned char *)CD_CMD_ADR, 0x00, CD_CMD_S);	//set buffer to zero
}

unsigned int atapi_cmd (unsigned char *buffer_in)
{
	unsigned char dummy;
	unsigned short timeout, byte_count;
	unsigned int temp;

	ERRNO = NO_ERROR;
	timeout = 0;
	while(  (*CB_STAT & CB_STAT_BSY) == CB_STAT_BSY )		// wait for BUSY=0 
	{
		delay_ms(1);
		if(timeout++ > ATAPI_CMD_TOUT)
		{
			ERRNO = ERR_ATAPI_TOUT;
			return 0;
		}
	}

	*ATAPI_BC_L = 12;			//init IDE POCKET command 
	*ATAPI_BC_H = 0;
	*CB_FR	= 0;
	*CB_SC = 0;
	*CB_SN = 0;
	*CB_CL = 0;
	*CB_CH = 0;
	*CB_CMD = CMD_PACKET;

	timeout=0;
	while(1)					//wait for DRQ
	{
		if (*CB_STAT & CB_STAT_BSY)  break;		//BSY=1
		if (*CB_STAT & CB_STAT_DRQ)  break;		//DRQ=1
		if (*CB_STAT & CB_STAT_ERR) 		  	//ERR=1
		{
			ERRNO = ERR_UNDEF;
			return 0;
		}
		if( timeout++ > ATAPI_CMD_TOUT)
		{
			ERRNO = ERR_ATAPI_TOUT;
			return 0;
		}
		delay_ms(1);
	}

	timeout=0;
	while(1)								// wait for BSY=0 
	{
		if(!(*CB_ASTAT & CB_STAT_BSY))	break;	//BSY=0
		if(timeout++ > ATAPI_CMD_TOUT)
		{
			ERRNO = ERR_ATAPI_TOUT;
			return 0;
		}
		delay_ms(1);
	}

	if( (*CB_STAT & (CB_STAT_DRQ | CB_STAT_BSY) ) != CB_STAT_DRQ)	// BSY=0 DRQ=1 now 
	{
		ERRNO = ERR_UNDEF;
		return 0;
	}

	{		
	unsigned char cmd* =(unsigned char *)CD_CMD_ADR;
		for(dummy=0;dummy <12 ; dummy=dummy + 2)		// write packet 
		{			
			*DATA_H = cmd[dummy +1];
			*CB_DATA = cmd[dummy];
		}
	}
	
	nop();	nop();
	
	timeout=0;
	while( (*CB_ASTAT & CB_STAT_BSY ) == CB_STAT_BSY) // wait for BSY == 0
	{
		if(timeout++ > ATAPI_CMD_TOUT)
		{
			ERRNO = ERR_ATAPI_TOUT;
			return 0;
		}
		delay_ms(1);
	}

	dummy = *CB_STAT;
	if( (dummy & CB_STAT_ERR) == CB_STAT_ERR)
	{
		ERRNO = ERR_UNDEF;
		return 0;
	}

	if( (dummy & CB_STAT_DRQ) == CB_STAT_DRQ )	// DATA transfer loop 
	{
		temp = 0;
		while(temp < ((*ATAPI_BC_H) << 8) | (*ATAPI_BC_L))
		{
			buffer_in[temp++] = *DATA_H;
			buffer_in[temp++] = *CB_DATA;
		}
		return temp;
	}
	else if( (*CB_ERR & 0xF0) > 0)
	{
		ERRNO = ERR_UNDEF;
		return 0;
	}
	return 0;
}

//return 0 if no error (got sense key !)
unsigned char get_sense( void)
{
unsigned char *cmd = (unsigned char *)CD_CMD_ADR;
	clr_cmd();
	cmd[0] = 0x03;	//request sense key
	cmd[4] = 0xFF;	//allocation len

	atapi_cmd(atapi_buffer);

	if( ERRNO == NO_ERROR)
	{
		ASC = atapi_buffer[12];
		ASCQ = atapi_buffer[13];
		return 0;
	}
	return ERRNO;
}

void slow_down(void)
{
unsigned char *cmd = (unsigned char *)CD_CMD_ADR;
	clr_cmd();
	cmd[0] = 0xBB;
	cmd[2] = 0x00;
	cmd[3] = 0x30;
	atapi_cmd(atapi_buffer);
}