
#include <io.h>
#include <signal.h>


#include "my_defs.h"
#include "memory.h"
#include "i2c.h"
#include "mas.h"
#include "serial.h"					 
#include "tools.h"
								  
void  i2c_delay(	unsigned char t )
{
	while(t-- >0);
}


void i2c_restart( void )
{
	SCL_low
	SDA_high
	i2c_delay(HP);
	SCL_high
	i2c_delay(QP);
	SDA_low			/* new start */
	i2c_delay(QP);
}

void i2c_start(void )
{
	SDA_low
	i2c_delay(QP);
}

void i2c_write( unsigned char data)
{
	unsigned char i;

	for(i=0; i<8; i++)
	{
		SCL_low
		sec();
		rol(data);
		if(carry_set())		SDA_high
		else				SDA_low
	
	i2c_delay(HP);
		SCL_high
	i2c_delay(HP);
	}
	SCL_low	//	ACK
	SDA_high
	i2c_delay(HP);
	SCL_high
	loop_until_bit_is_set(PIND, SCL);
	i2c_delay(HP);
}

unsigned char i2c_read( unsigned char more_bytes)
{
	unsigned char data;
	unsigned char i;

	data = 0;
	SCL_low
	SDA_high

	for(i=0; i<8 ; i++)
	{
		SCL_low
		i2c_delay(HP);
		SCL_high
		i2c_delay(HP);
		if(SDA_SET)
			sec();
		else
			clc();
		rol(data);
	}

	SCL_low
	if( more_bytes == TRUE)		SDA_low
	else						SDA_high
	i2c_delay(HP);
	SCL_high
	loop_until_bit_is_set(PIND, SCL);
	i2c_delay(HP);
	return data;
}

void i2c_receive(unsigned char count)
{
	unsigned char i;

	for(i=0; i<(count-1); i++)
		_local_buffer[i] = i2c_read(TRUE);
	_local_buffer[i] = i2c_read(FALSE);
	i2c_stop();
}

void i2c_send(unsigned char count)
{
unsigned char i;

	for(i=0; i< count; i++)
		i2c_write(_local_buffer[i]);
}

void i2c_stop( void)
{
	SCL_low
	SDA_low
	i2c_delay(HP);
	SCL_high
	i2c_delay(QP);
	SDA_high
	i2c_delay(HP);
}

void inline i2c_init( void)
{
//	sbi( DDRD, SCL);
//	SCL_high
//	SDA_high
}

