/*
#define for slave routines
*/


#ifndef ___I2C_H
#define ___I2C_H


#if MINIMEGAHMPEG == FALSE	// Hmpeg
	#define SCL	PD5
	#define SCL_low		cbi( PORTD, SCL);
	#define SCL_high 	sbi( PORTD, SCL);
	
	#define	SDA	PB1
	#define SDA_low		{cbi( PORTB, SDA); sbi( DDRB, SDA);}
	#define SDA_high	{cbi( DDRB, SDA); sbi( PORTB, SDA);}

	#define SDA_SET		bit_is_set(PINB, SDA)
#else	// MiniMegaHmpeg
	#define SCL	PD6
	#define SCL_low		cbi( PORTD, SCL);
	#define SCL_high 	sbi( PORTD, SCL);
	
	#define	SDA	PD7
	#define SDA_low		{cbi( PORTD, SDA); sbi( DDRD, SDA);}
	#define SDA_high	{cbi( DDRD, SDA); sbi( PORTD, SDA);}

	#define SDA_SET		bit_is_set(PIND, SDA)
#endif


#define	QP			1
#define	HP			2*QP
#define I2C_READ 	1
#define I2C_WRITE	0
#define SLAVE		0xae

void i2c_init(void);
void i2c_delay( unsigned char t );

void i2c_write( unsigned char data);
void i2c_send( unsigned char count);


unsigned char i2c_read( unsigned char more_bytes);
void i2c_receive(unsigned char count);

void i2c_stop( void);
void i2c_restart( void );
void i2c_start(void );

/* darf nicht auf 0x01 enden !!!*/
#define	my_i2c_adr	0x50


/*
	CD	CD	CD	CD
CD	00	01	10	11
10	ND	IL	XX	EN
11	IL	ND	ST	XX

&
	00	01	10	11
10	00	IL	XX	10
11	IL	01	10	XX


IL -> illegal
ND -> new data (next byte)
SD -> stop or data (?????)
EN -> end (stop) condition
ST -> start condition
XX -> now possible
*/

#endif
